%global gemdir %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global gemname rack-mount
%global geminstdir %{gemdir}/gems/%{gemname}-%{version}

%global testdir %{_tmppath}/%{gemname}-%{version}

Summary: Stackable dynamic tree based Rack router
Name: rubygem-%{gemname}
Version: 0.7.1
Release: 8%{?dist}
Group: Development/Languages
License: MIT
URL: http://github.com/josh/%{gemname}
Source0: http://rubygems.org/gems/%{gemname}-%{version}.gem
# git clone https://github.com/josh/rack-mount.git && cd rack-mount && git checkout v0.7.1
# tar czvf rack-mount-tests.tgz test/
Source1: %{gemname}-tests.tgz
# Add dependency on unbundeld regin.
Patch1: rack-mount-add-regin-deps.patch
Patch2: rack-mount-Fix-hash-order-dependent-test-failure.patch
Requires: ruby(abi) = 1.8
Requires: rubygems
Requires: rubygem(rack) >= 1.1.0
Requires: rubygem(regin)
BuildRequires: rubygems
BuildRequires: rubygem(rack) >= 1.1.0
BuildRequires: rubygem(regin)
BuildArch: noarch
Provides: rubygem(%{gemname}) = %{version}

%description
Stackable dynamic tree based Rack router. Supports Rack’s X-Cascade convention
to continue trying routes if the response returns pass. This allows multiple
routes to be nested or stacked on top of each other. Since the application
endpoint can trigger the router to continue matching, middle-ware can be used
to add arbitrary conditions to any route. This allows you to route based
on other request attributes, session information, or even data dynamically
pulled from a database.


%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires:%{name} = %{version}-%{release}

%description doc
Documentation for %{name}

%prep
%setup -q -c -T
mkdir -p .%{gemdir}
gem install --local --install-dir .%{gemdir} \
            --force %{SOURCE0}

pushd .%{gemdir}
%patch1 -p0
rm -f specifications/rack-mount-0.7.1.gemspec.orig
popd

rm -rf %{testdir}
mkdir %{testdir}
tar xzvf %{SOURCE1} -C %{testdir}
pushd %{testdir}
%patch2 -p1
popd

%build

%install
mkdir -p %{buildroot}%{gemdir}
cp -a .%{gemdir}/* \
        %{buildroot}%{gemdir}/

rm -rf %{buildroot}%{geminstdir}/lib/rack/mount/vendor

%check
pushd %{testdir}
RUBYOPT="$RUBYOPT rubygems I%{buildroot}%{geminstdir}/lib I./test" testrb test/test_*
popd
rm -rf %{testdir}


%files
%defattr(-, root, root, -)
%dir %{geminstdir}
%{geminstdir}/lib
%doc %{geminstdir}/LICENSE
%doc %{geminstdir}/README.rdoc
%{gemdir}/cache/%{gemname}-%{version}.gem
%{gemdir}/specifications/%{gemname}-%{version}.gemspec

%files doc
%defattr(-, root, root, -)
%doc %{gemdir}/doc/%{gemname}-%{version}

%changelog
* Tue Oct 16 2012 Brenton Leanhardt <bleanhar@redhat.com> - 0.7.1-8
- Release bump for brew

* Mon Mar 19 2012 John Eckersberg <jeckersb@redhat.com> - 0.7.1-7
- Add patch to fix hash-order dependent test failure

* Tue Sep 23 2011 Shannon Hughes <shughes@redhat.com> - 0.7.1-6
- Adjust patch to math correct lines in rhel6.

* Tue Jun 28 2011 Vít Ondruch <vondruch@redhat.com> - 0.7.1-3
- Relaxed Rack dependency.

* Fri Jun 03 2011 Vít Ondruch <vondruch@redhat.com> - 0.7.1-2
- Fixed missing dependencies after unbundling regin.

* Thu Apr 07 2011 Vít Ondruch <vondruch@redhat.com> - 0.7.1-1
- Updated to rack-mount 0.7.1

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.13-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Fri Jan 28 2011 Vít Ondruch <vondruch@redhat.com> - 0.6.13-4
- Fixed test execution

* Wed Jan 26 2011 Vít Ondruch <vondruch@redhat.com> - 0.6.13-3
- Fixed vendor subdirectory removal
- Added test dir cleanup on the beginning of %check section

* Wed Jan 19 2011 Vít Ondruch <vondruch@redhat.com> - 0.6.13-2
- Added missing prep, build and clean sections
- Added missing dependency on rubygem-rack
- Removed unnecessary cleanup
- Removed vendored Regin and Multimap gems
- Added exection of test suite

* Fri Jan 07 2011 Vít Ondruch <vondruch@redhat.com> - 0.6.13-1
- Initial package
